<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Ed</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - Ed
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Ed</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#orgfaa1507">About Ed</a></li>
<li><a href="#org19c7275">Getting started</a>
<ul>
<li><a href="#org8020bf9">Start ed, editing an empty document (which can be saved as a new file in the current directory):</a></li>
<li><a href="#orgc8da9ea">Start ed, editing an empty document, with `:` as a command prompt indicator:</a></li>
<li><a href="#org1db03f4">Start ed editing an existing file (this shows the byte count of the loaded file):</a></li>
<li><a href="#orgc265065">Toggle the printing of error explanations. (By default, explanations are not printed and only a &rsquo;?&rsquo; appears):</a></li>
</ul>
</li>
<li><a href="#orge9c0141">Add text to the current document:</a>
<ul>
<li><a href="#org702b698">Add text on line after current line:</a></li>
<li><a href="#org272bdb6">Add text on line before current line:</a></li>
</ul>
</li>
<li><a href="#org2ee254b">Print</a>
<ul>
<li><a href="#org7bbe66e">The entire document (`,` is a shortcut to the range `1,$` which covers the start to the end of the document):</a></li>
<li><a href="#org4336278">The current line</a></li>
<li><a href="#org14b6503">A specific line number or range</a></li>
<li><a href="#org53e3e4f">To print with the line number:</a></li>
</ul>
</li>
<li><a href="#orgbb159a2">Change a line:</a></li>
<li><a href="#org8450900">Delete a line:</a></li>
<li><a href="#org93f573b">Undo last command:</a></li>
<li><a href="#org5fde9a5">To copy a line and paste it at some other location:</a>
<ul>
<li><a href="#orgfd3cc18">Copy line 2 to position 0:</a></li>
<li><a href="#orga74e36b">Move line 2 to position 0:</a></li>
</ul>
</li>
<li><a href="#org4ee7901">To search forward:</a></li>
<li><a href="#org8df613c">Global command:</a></li>
<li><a href="#org0db8f79">Substitute command:</a>
<ul>
<li><a href="#org55557f7">Substitution</a></li>
<li><a href="#org296dd5b">Repeat last substitution</a></li>
</ul>
</li>
<li><a href="#orgf6fe829">Run shell commands inside ed:</a></li>
<li><a href="#org88bd9a3">Write the current document to a new file (the filename can be omitted if `ed` was called with an existing file):</a></li>
<li><a href="#org7e6a8eb">Quit ed:</a>
<ul>
<li><a href="#org695498b">Footer</a></li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-orgfaa1507" class="outline-2">
<h2 id="orgfaa1507">About Ed</h2>
<div class="outline-text-2" id="text-orgfaa1507">
<p>
GNU ed is a line-oriented text editor. It is used to create, display, modify and otherwise manipulate text files, both interactively and via shell scripts. A restricted version of ed, red, can only edit files in the current directory and cannot execute shell commands. Ed is the &rsquo;standard&rsquo; text editor in the sense that it is the  original editor for Unix, and thus widely available. For most purposes, however, it is superseded by full-screen editors such as GNU Emacs or Vi/Vim.
</p>

<p>
(In)famous for its terseness, ed gives almost no visual feedback. For example, ed does not display a prompt by default, which is really confusing since there are two modes in ed: command mode and insert mode.  But without a prompt, it&rsquo;s difficult to tell which mode you are in. Another example of ed&rsquo;s terseness, the message that ed produces in case of error, or when it wants to make sure the user wishes to quit without saving, is &ldquo;?&rdquo;. It does not report the current filename or line number, or even display the results of a change to the text, unless requested. Older versions (c. 1981) did not even ask for confirmation when a quit command was issued without the user saving changes.
</p>

<p>
This terseness was appropriate in the early versions of Unix, when consoles were teletypes, modems were slow, and memory was precious. Every character printed meant time, paper, ink and mechanical wear. As computer technology improved and these constraints were loosened, editors with more visual feedback became the norm.
</p>

<p>
In current practice, ed is rarely used interactively, but does find use in some shell scripts. For interactive use, ed was subsumed by the vi and Emacs editors in the 1980s. That being said, ed can still be found on virtually every version of Unix and Linux available, and as such is useful for people who have to work with multiple versions of Unix.
</p>

<p>
<code>NOTE:</code> ed is not installed by default on Arco Linux.
</p>
</div>
</div>

<div id="outline-container-org19c7275" class="outline-2">
<h2 id="org19c7275">Getting started</h2>
<div class="outline-text-2" id="text-org19c7275">
</div>
<div id="outline-container-org8020bf9" class="outline-3">
<h3 id="org8020bf9">Start ed, editing an empty document (which can be saved as a new file in the current directory):</h3>
<div class="outline-text-3" id="text-org8020bf9">
<p>
ed
</p>
</div>
</div>

<div id="outline-container-orgc8da9ea" class="outline-3">
<h3 id="orgc8da9ea">Start ed, editing an empty document, with `:` as a command prompt indicator:</h3>
<div class="outline-text-3" id="text-orgc8da9ea">
<p>
ed -p :
</p>
</div>
</div>

<div id="outline-container-org1db03f4" class="outline-3">
<h3 id="org1db03f4">Start ed editing an existing file (this shows the byte count of the loaded file):</h3>
<div class="outline-text-3" id="text-org1db03f4">
<p>
ed -p : path/to/file
</p>
</div>
</div>

<div id="outline-container-orgc265065" class="outline-3">
<h3 id="orgc265065">Toggle the printing of error explanations. (By default, explanations are not printed and only a &rsquo;?&rsquo; appears):</h3>
<div class="outline-text-3" id="text-orgc265065">
<p>
H
</p>
</div>
</div>
</div>

<div id="outline-container-orge9c0141" class="outline-2">
<h2 id="orge9c0141">Add text to the current document:</h2>
<div class="outline-text-2" id="text-orge9c0141">
</div>
<div id="outline-container-org702b698" class="outline-3">
<h3 id="org702b698">Add text on line after current line:</h3>
<div class="outline-text-3" id="text-org702b698">
<pre class="example" id="org0dc7015">
a&lt;Enter&gt;text_to_insert&lt;Enter&gt;.
</pre>
<p>
Mark completion by entering a period by itself in a new line.
<code>NOTE:</code> Adds this line after the line your currently on.
</p>
</div>
</div>
<div id="outline-container-org272bdb6" class="outline-3">
<h3 id="org272bdb6">Add text on line before current line:</h3>
<div class="outline-text-3" id="text-org272bdb6">
<pre class="example" id="org4c1f096">
i&lt;Enter&gt;text_to_insert&lt;Enter&gt;.
</pre>
<p>
Mark completion by entering a period by itself in a new line.
</p>
</div>
</div>
</div>

<div id="outline-container-org2ee254b" class="outline-2">
<h2 id="org2ee254b">Print</h2>
<div class="outline-text-2" id="text-org2ee254b">
</div>
<div id="outline-container-org7bbe66e" class="outline-3">
<h3 id="org7bbe66e">The entire document (`,` is a shortcut to the range `1,$` which covers the start to the end of the document):</h3>
<div class="outline-text-3" id="text-org7bbe66e">
<ul class="org-ul">
<li>,p</li>
</ul>
</div>
</div>
<div id="outline-container-org4336278" class="outline-3">
<h3 id="org4336278">The current line</h3>
<div class="outline-text-3" id="text-org4336278">
<ul class="org-ul">
<li>p</li>
</ul>
</div>
</div>
<div id="outline-container-org14b6503" class="outline-3">
<h3 id="org14b6503">A specific line number or range</h3>
<div class="outline-text-3" id="text-org14b6503">
<ul class="org-ul">
<li>2p (line 2)</li>
<li>or just type &rsquo;2&rsquo; without the p</li>
<li>-1p (one line up from current line)</li>
<li>+2p (two lines down from current line)</li>
<li>1,2p (lines 1-2)</li>
</ul>
</div>
</div>
<div id="outline-container-org53e3e4f" class="outline-3">
<h3 id="org53e3e4f">To print with the line number:</h3>
<div class="outline-text-3" id="text-org53e3e4f">
<ul class="org-ul">
<li>n (instead of p)</li>
</ul>
</div>
</div>
</div>

<div id="outline-container-orgbb159a2" class="outline-2">
<h2 id="orgbb159a2">Change a line:</h2>
<div class="outline-text-2" id="text-orgbb159a2">
<p>
c&lt;Enter&gt;text_to_insert&lt;Enter&gt;.
Mark completion by entering a period by itself in a new line.
Ranges can be used: (.,.)c
</p>
</div>
</div>

<div id="outline-container-org8450900" class="outline-2">
<h2 id="org8450900">Delete a line:</h2>
<div class="outline-text-2" id="text-org8450900">
<p>
(.,.)d
Just &rsquo;d&rsquo; deletes last line.
</p>
</div>
</div>

<div id="outline-container-org93f573b" class="outline-2">
<h2 id="org93f573b">Undo last command:</h2>
<div class="outline-text-2" id="text-org93f573b">
<p>
u
</p>
</div>
</div>

<div id="outline-container-org5fde9a5" class="outline-2">
<h2 id="org5fde9a5">To copy a line and paste it at some other location:</h2>
<div class="outline-text-2" id="text-org5fde9a5">
</div>
<div id="outline-container-orgfd3cc18" class="outline-3">
<h3 id="orgfd3cc18">Copy line 2 to position 0:</h3>
<div class="outline-text-3" id="text-orgfd3cc18">
<p>
2t0
</p>
</div>
</div>
<div id="outline-container-orga74e36b" class="outline-3">
<h3 id="orga74e36b">Move line 2 to position 0:</h3>
<div class="outline-text-3" id="text-orga74e36b">
<p>
2m0
</p>
</div>
</div>
</div>

<div id="outline-container-org4ee7901" class="outline-2">
<h2 id="org4ee7901">To search forward:</h2>
<div class="outline-text-2" id="text-org4ee7901">
<p>
/keyword&lt;ENTER&gt;
The editor will display the first line (containing the keyword) it encounters. You can run that command again to continue searching.
</p>
</div>
</div>

<div id="outline-container-org8df613c" class="outline-2">
<h2 id="org8df613c">Global command:</h2>
<div class="outline-text-2" id="text-org8df613c">
<p>
(1,$)g/re/command
g/re/p (search for string or regex and print lines containing the pattern)
</p>

<p>
<code>NOTE:</code> The g/re/p command was so commonly used that a separate &rsquo;grep&rsquo; program was eventually created.
</p>
</div>
</div>

<div id="outline-container-org0db8f79" class="outline-2">
<h2 id="org0db8f79">Substitute command:</h2>
<div class="outline-text-2" id="text-org0db8f79">
</div>
<div id="outline-container-org55557f7" class="outline-3">
<h3 id="org55557f7">Substitution</h3>
<div class="outline-text-3" id="text-org55557f7">
<p>
(.,.)s/re/replacement/
</p>
</div>
</div>
<div id="outline-container-org296dd5b" class="outline-3">
<h3 id="org296dd5b">Repeat last substitution</h3>
<div class="outline-text-3" id="text-org296dd5b">
<p>
(.,.)s
</p>
</div>
</div>
</div>

<div id="outline-container-orgf6fe829" class="outline-2">
<h2 id="orgf6fe829">Run shell commands inside ed:</h2>
<div class="outline-text-2" id="text-orgf6fe829">
<ul class="org-ul">
<li>!command</li>
<li>r !command (reads the output and stores it temporarily in a buffer)</li>
<li>w (writes the file)</li>
</ul>
</div>
</div>

<div id="outline-container-org88bd9a3" class="outline-2">
<h2 id="org88bd9a3">Write the current document to a new file (the filename can be omitted if `ed` was called with an existing file):</h2>
<div class="outline-text-2" id="text-org88bd9a3">
<ul class="org-ul">
<li>w filename</li>
</ul>
</div>
</div>

<div id="outline-container-org7e6a8eb" class="outline-2">
<h2 id="org7e6a8eb">Quit ed:</h2>
<div class="outline-text-2" id="text-org7e6a8eb">
<ul class="org-ul">
<li>q</li>
<li>wq (write and quit)</li>
</ul>
</div>

<div id="outline-container-org695498b" class="outline-3">
<h3 id="org695498b">Footer</h3>
<div class="outline-text-3" id="text-org695498b">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
